/***************************************************************
* "Copyright 2003 Stephen Morris 
* Source code files from the 1st edition of the book
* "Network Management, MIBs, & MPLS." All rights 
* reserved except as allowed by the following statements: 
* You can freely use these files
* for your own work (personal or commercial),
* including modifications and distribution in
* executable form only. Permission is granted to use
* these files in instructional situations, including its
* use in presentation materials, as long as the book
* "Network Management, MIBs, & MPLS" is cited as the source. 
* You cannot remove this copyright and notice. You cannot distribute
* modified versions of the source code in this
* package. You cannot use these files in printed
* media without the express permission of the
* author. Stephen Morris makes no representation about
* the suitability of this software for any purpose.
* It is provided "as is" without express or implied
* warranty of any kind, including any implied
* warranty of merchantability, fitness for a
* particular purpose or non-infringement. The entire
* risk as to the quality and performance of the
* software is with you. Stephen Morris and the
* publisher shall not be liable for any damages
* suffered by you or any third party as a result of
* using or distributing the software. In no event will
* Stephen Morris or the publisher be liable for any
* lost revenue, profit, or data, or for direct,
* indirect, special, consequential, incidental, or
* punitive damages, however caused and regardless of
* the theory of liability, arising out of the use of
* or inability to use software, even if Stephen Morris
* and the publisher have been advised of the
* possibility of such damages. Should the software
* prove defective, you assume the cost of all
* necessary servicing, repair, or correction."
****************************************************************/

/****************** SECTION 1 ******************/
#define TIMEOUT 6000 /* milliseconds */
#define RETRIES 3
#define MAX_OID_NAME_LENGTH 50
#define FUNCTION_SUCCESS 0
#define FUNCTION_FAILED -1

enum Operations { GET, GETNEXT, SET, WALK, TRAP };
char * operationsArray[5] = { "GET", "GETNEXT", "SET", "WALK", "TRAP" };

/****************** SECTION 2 ******************/
INT programMode, operation;
LPSTR SNMPAgentName, SNMPCommunity, OIDstring;
RFC1157VarBindList variableBindings;
LPSNMP_MGR_SESSION SNMPsession;
AsnAny retrievedInstanceValue;
INT timeout = TIMEOUT;
INT retries = RETRIES;
BYTE requestType;
AsnInteger errorStatus, errorIndex;

/****************** SECTION 3 ******************/
int allocateResources(LPSTR agentName, LPSTR community,
                char *objectIdentifier);
int deallocateResources();
int prepareForOp(enum Operations reqOperation, LPSTR agentName,
			LPSTR community, char *objectIdentifier, char *objectValue);
int prepareDataForOperation(enum Operations reqOperation, 
                unsigned char *newObjectValue);
int prepareSetOperation(unsigned char *newObjectValue);
int prepareGetOperation();
int prepareGetNextOperation();
int dispatchOperation(int programMode, char * argumentVector[]);
int createSNMPSession();
int executeRequest();
int displayMIBInstanceValue();
int doSnmpOperation(enum Operations reqOperation, LPSTR agentName,
                LPSTR community, char *objectIdentifier, char *objectValue);
int executeMibWalk();
int waitForTraps();
int startupRoutine(int argc, char *argv []);